SoGLVBOElement(3)

NAME
SoGLVBOElement - The SoGLVBOElement class is used to store VBO state.

SYNOPSIS

#include <Inventor/elements/SoGLVBOElement.h>

Inherits SoElement.

  Public Member Functions
virtual void init (SoState *state)
virtual void push (SoState *state)
virtual void pop (SoState *state, const SoElement *prevtopelement)
virtual SbBool matches (const SoElement *elt) const
virtual SoElement * copyMatchInfo (void) const
SoVBO * getVertexVBO (void) const
SoVBO * getNormalVBO (void) const
SoVBO * getColorVBO (void) const
int getNumTexCoordVBO (void) const
SoVBO * getTexCoordVBO (const int idx) const
Public Member Functions inherited from SoElement
const SoType getTypeId (void) const
int getStackIndex (void) const
void setDepth (const int depth)
int getDepth (void) const
virtual void print (FILE *file=stdout) const
virtual ~SoElement ()

  Static Public Member Functions
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void * createInstance (void)
static void initClass (void)
static SbBool shouldCreateVBO (SoState *state, const int numdata)
static void setVertexVBO (SoState *state, SoVBO *vbo)
static void setNormalVBO (SoState *state, SoVBO *vbo)
static void setColorVBO (SoState *state, SoVBO *vbo)
static void setTexCoordVBO (SoState *state, const int unit, SoVBO *vbo)
static const SoGLVBOElement * getInstance (SoState *state)
Static Public Member Functions inherited from SoElement
static void initClass (void)
static SoType getClassTypeId (void)
static int getClassStackIndex (void)
static void initElements (void)
static int getNumStackIndices (void)
static SoType getIdFromStackIndex (const int stackIndex)

  Protected Member Functions
SoGLVBOElement (void)
virtual ~SoGLVBOElement ()
Protected Member Functions inherited from SoElement
SoElement (void)
void capture (SoState *const state) const
virtual void captureThis (SoState *state) const
void setTypeId (const SoType typeId)
void setStackIndex (const int index)
SoElement * getNextInStack (void) const
SoElement * getNextFree (void) const

  Static Protected Member Functions
static SoGLVBOElement * getElement (SoState *state)
Static Protected Member Functions inherited from SoElement
static SoElement * getElement (SoState *const state, const int stackIndex)
static const SoElement * getConstElement (SoState *const state, const int stackIndex)
static int createStackIndex (const SoType id)

  Additional Inherited Members
Protected Attributes inherited from SoElement
SoType typeId
int stackIndex
int depth
Static Protected Attributes inherited from SoElement
static int classStackIndex
static SoTypeList * stackToType

Detailed Description

The SoGLVBOElement class is used to store VBO state. FIXME: write doc.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
    Coin 2.5

Constructor & Destructor Documentation

  SoGLVBOElement::SoGLVBOElement (void ) [protected]
Constructor.

  SoGLVBOElement::~SoGLVBOElement () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoGLVBOElement::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  int SoGLVBOElement::getClassStackIndex (void ) [static]
This static method returns the state stack index for the class.

  void * SoGLVBOElement::createInstance (void ) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Creates a new instance of the class type corresponding to the SoType object.

  void SoGLVBOElement::initClass (void ) [static]
Initialize relevant common data for all instances, like the type system.

  SbBool SoGLVBOElement::shouldCreateVBO (SoState * state, const int numdata) [static]
Returns TRUE if VBO is supported for the current context, and if numdata is between the limits set for VBO rendering.

  void SoGLVBOElement::setVertexVBO (SoState * state, SoVBO * vbo) [static]
Sets the vertex VBO.

  void SoGLVBOElement::setNormalVBO (SoState * state, SoVBO * vbo) [static]
Sets the normal VBO.

  void SoGLVBOElement::setColorVBO (SoState * state, SoVBO * vbo) [static]
Sets the color VBO.

  void SoGLVBOElement::setTexCoordVBO (SoState * state, const int unit, SoVBO * vbo) [static]
Sets the texture coordinate VBO.

  const SoGLVBOElement * SoGLVBOElement::getInstance (SoState * state) [static]
Returns a read-only element instance.

  void SoGLVBOElement::init (SoState * state) [virtual]
This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoElement.

  void SoGLVBOElement::push (SoState * state) [virtual]
This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

  void SoGLVBOElement::pop (SoState * state, const SoElement * prevTopElement) [virtual]
This method is called when the state is popped, and the depth of the element is bigger than the current state depth. pop() is called on the new top of stack, and a pointer to the previous top of stack is passed in prevTopElement.

Override this method if you need to copy some state information from the previous top of stack.

Reimplemented from SoElement.

  SbBool SoGLVBOElement::matches (const SoElement * element) const [virtual]
This function returns TRUE is the element matches another element (of the same class), with respect to cache validity.

If the application programmer's extension element has a matches() function, it should also have a copyMatchInfo() function.

Implements SoElement.

  SoElement * SoGLVBOElement::copyMatchInfo (void ) const [virtual]
This function creates a copy of the element that contains enough information to enable the matches() function to work.

Used to help with scene graph traversal caching operations.

Implements SoElement.

  SoGLVBOElement * SoGLVBOElement::getElement (SoState * state) [static], [protected]
Returns a writable element instance.

Author

Generated automatically by Doxygen for Coin from the source code.